/*  
		Bildquellen Verzeichnis 
		Version:     	1.0
		License:	CC 
		Last-Change:	10.01.2010

	Gregor Fellenz
	http://www.indesignblog.com/
*/

#target InDesign


// Ab CS4 Skript Undo-Fhigkeit herstellen
try {
	if (app.version.substring(0,1) >= "6") {
		var undoName = "Bildquellen.jsx";
		app.doScript(main, undefined , undefined,UndoModes.fastEntireScript , undoName ); 
	} 
	else {
		if (app.version.substring(0,1) == "5") { main(); }
		else { alert ("Es wird mindestens InDesign CS3 bentigt ...") }
	}
} 
catch (e) {
	alert("Es ist ein Fehler aufgetreten!\n" + e + 
			"\nZeile: " + e.line  +
			"\nSkript: " + e.fileName );
}


function main () {
	if (app.documents.length == 0) {
		alert ("Kein Dokument geffnet!");
		return;		
	}
	var _dok = app.activeDocument;

	var myOldXUnits = _dok.viewPreferences.horizontalMeasurementUnits;
	var myOldYUnits = _dok.viewPreferences.verticalMeasurementUnits;
	var myOldInteraction = app.scriptPreferences.userInteractionLevel;
	_dok.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
	_dok.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;
		
	var _bildQuellen = [];
		
	for (var i =0 ; i < _dok.links.length; i++) {
		try {
			_bildQuellen.push([_dok.links[i].linkXmp.author, getPageByObject(_dok.links[i]).name] )
		} catch (e) {/* keine Metadaten vorhanden ... */ }
	}
	_bildQuellen.sort(sortCreator);	
	var _newPage = _dok.pages.add();
	var _tf = _newPage.textFrames.add()
	_tf.geometricBounds = [36,36,247.465 ,559.276 ];
	
	_tf.contents = "Bildquellenverzeichnis\r" +  _bildQuellen[0][0] + "\t"+ _bildQuellen[0][1];
	for (var i =1; i <_bildQuellen.length; i++) {
		if (_bildQuellen[i][0] == _bildQuellen[i-1][0])  _tf.contents = _tf.contents + ", " + _bildQuellen[i][1];
		else _tf.contents = _tf.contents + "\r" + _bildQuellen[i][0] + "\t"+ _bildQuellen[i][1];
	}	

	_dok.viewPreferences.horizontalMeasurementUnits = myOldXUnits;
	_dok.viewPreferences.verticalMeasurementUnits = myOldYUnits;
	app.scriptPreferences.userInteractionLevel = myOldInteraction;
}

function sortCreator(a,b) {
	var x = dU(a[0]);
	var y = dU(b[0]);
	return(x==y)?0:(x>y)?1:-1;		
}
/** Deutsche Umlaute ersetzen */ 
function dU (a) {
	a = a.toLowerCase();
	a = a.replace(//g,"a");
	a = a.replace(//g,"o");
	a = a.replace(//g,"u");
	a = a.replace(//g,"s");	
	return	a;
}


function getPageByObject (_object) {
	if (_object != null) {
		_object = _object.getElements ()[0]; // Problems with Baseclass Objects like PageItem in CS5!
		if (_object.hasOwnProperty("baseline")) {
			_object = _object.parentTextFrames[0];
		}
		while (_object != null) {
			if (_object.hasOwnProperty ("parentPage")) return _object.parentPage;
			var whatIsIt = _object.constructor;
			switch (whatIsIt) {
				case Page : return _object;
				case Character : _object = _object.parentTextFrames[0]; break;
				case Footnote :; // drop through
				case Cell : _object = _object.insertionPoints[0].parentTextFrames[0]; break;
				case Note : _object = _object.storyOffset.parentTextFrames[0]; break;
				case XMLElement : if (_object.insertionPoints[0] != null) { _object = _object.insertionPoints[0].parentTextFrames[0]; break; }
				case Application : return null;
				default: _object = _object.parent;
			}
			if (_object == null) return null;
		}
		return _object;	
	} 
	else {
		return null;
	}
}
